// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from oxts_msgs:msg/ImuBias.idl
// generated code does not contain a copyright notice
#include "oxts_msgs/msg/detail/imu_bias__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `accel`
// Member `gyro`
#include "geometry_msgs/msg/detail/vector3__functions.h"

bool
oxts_msgs__msg__ImuBias__init(oxts_msgs__msg__ImuBias * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    oxts_msgs__msg__ImuBias__fini(msg);
    return false;
  }
  // accel
  if (!geometry_msgs__msg__Vector3__init(&msg->accel)) {
    oxts_msgs__msg__ImuBias__fini(msg);
    return false;
  }
  // gyro
  if (!geometry_msgs__msg__Vector3__init(&msg->gyro)) {
    oxts_msgs__msg__ImuBias__fini(msg);
    return false;
  }
  return true;
}

void
oxts_msgs__msg__ImuBias__fini(oxts_msgs__msg__ImuBias * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // accel
  geometry_msgs__msg__Vector3__fini(&msg->accel);
  // gyro
  geometry_msgs__msg__Vector3__fini(&msg->gyro);
}

bool
oxts_msgs__msg__ImuBias__are_equal(const oxts_msgs__msg__ImuBias * lhs, const oxts_msgs__msg__ImuBias * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // accel
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->accel), &(rhs->accel)))
  {
    return false;
  }
  // gyro
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->gyro), &(rhs->gyro)))
  {
    return false;
  }
  return true;
}

bool
oxts_msgs__msg__ImuBias__copy(
  const oxts_msgs__msg__ImuBias * input,
  oxts_msgs__msg__ImuBias * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // accel
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->accel), &(output->accel)))
  {
    return false;
  }
  // gyro
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->gyro), &(output->gyro)))
  {
    return false;
  }
  return true;
}

oxts_msgs__msg__ImuBias *
oxts_msgs__msg__ImuBias__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  oxts_msgs__msg__ImuBias * msg = (oxts_msgs__msg__ImuBias *)allocator.allocate(sizeof(oxts_msgs__msg__ImuBias), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(oxts_msgs__msg__ImuBias));
  bool success = oxts_msgs__msg__ImuBias__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
oxts_msgs__msg__ImuBias__destroy(oxts_msgs__msg__ImuBias * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    oxts_msgs__msg__ImuBias__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
oxts_msgs__msg__ImuBias__Sequence__init(oxts_msgs__msg__ImuBias__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  oxts_msgs__msg__ImuBias * data = NULL;

  if (size) {
    data = (oxts_msgs__msg__ImuBias *)allocator.zero_allocate(size, sizeof(oxts_msgs__msg__ImuBias), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = oxts_msgs__msg__ImuBias__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        oxts_msgs__msg__ImuBias__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
oxts_msgs__msg__ImuBias__Sequence__fini(oxts_msgs__msg__ImuBias__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      oxts_msgs__msg__ImuBias__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

oxts_msgs__msg__ImuBias__Sequence *
oxts_msgs__msg__ImuBias__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  oxts_msgs__msg__ImuBias__Sequence * array = (oxts_msgs__msg__ImuBias__Sequence *)allocator.allocate(sizeof(oxts_msgs__msg__ImuBias__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = oxts_msgs__msg__ImuBias__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
oxts_msgs__msg__ImuBias__Sequence__destroy(oxts_msgs__msg__ImuBias__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    oxts_msgs__msg__ImuBias__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
oxts_msgs__msg__ImuBias__Sequence__are_equal(const oxts_msgs__msg__ImuBias__Sequence * lhs, const oxts_msgs__msg__ImuBias__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!oxts_msgs__msg__ImuBias__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
oxts_msgs__msg__ImuBias__Sequence__copy(
  const oxts_msgs__msg__ImuBias__Sequence * input,
  oxts_msgs__msg__ImuBias__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(oxts_msgs__msg__ImuBias);
    oxts_msgs__msg__ImuBias * data =
      (oxts_msgs__msg__ImuBias *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!oxts_msgs__msg__ImuBias__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          oxts_msgs__msg__ImuBias__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!oxts_msgs__msg__ImuBias__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
