// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from oxts_msgs:msg/ImuBias.idl
// generated code does not contain a copyright notice

#ifndef OXTS_MSGS__MSG__DETAIL__IMU_BIAS__STRUCT_HPP_
#define OXTS_MSGS__MSG__DETAIL__IMU_BIAS__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'accel'
// Member 'gyro'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__oxts_msgs__msg__ImuBias __attribute__((deprecated))
#else
# define DEPRECATED__oxts_msgs__msg__ImuBias __declspec(deprecated)
#endif

namespace oxts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ImuBias_
{
  using Type = ImuBias_<ContainerAllocator>;

  explicit ImuBias_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    accel(_init),
    gyro(_init)
  {
    (void)_init;
  }

  explicit ImuBias_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    accel(_alloc, _init),
    gyro(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _accel_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _accel_type accel;
  using _gyro_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _gyro_type gyro;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__accel(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->accel = _arg;
    return *this;
  }
  Type & set__gyro(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->gyro = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    oxts_msgs::msg::ImuBias_<ContainerAllocator> *;
  using ConstRawPtr =
    const oxts_msgs::msg::ImuBias_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<oxts_msgs::msg::ImuBias_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<oxts_msgs::msg::ImuBias_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      oxts_msgs::msg::ImuBias_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<oxts_msgs::msg::ImuBias_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      oxts_msgs::msg::ImuBias_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<oxts_msgs::msg::ImuBias_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<oxts_msgs::msg::ImuBias_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<oxts_msgs::msg::ImuBias_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__oxts_msgs__msg__ImuBias
    std::shared_ptr<oxts_msgs::msg::ImuBias_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__oxts_msgs__msg__ImuBias
    std::shared_ptr<oxts_msgs::msg::ImuBias_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ImuBias_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->accel != other.accel) {
      return false;
    }
    if (this->gyro != other.gyro) {
      return false;
    }
    return true;
  }
  bool operator!=(const ImuBias_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ImuBias_

// alias to use template instance with default allocator
using ImuBias =
  oxts_msgs::msg::ImuBias_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace oxts_msgs

#endif  // OXTS_MSGS__MSG__DETAIL__IMU_BIAS__STRUCT_HPP_
