// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from oxts_msgs:msg/LeverArm.idl
// generated code does not contain a copyright notice
#include "oxts_msgs/msg/detail/lever_arm__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `lever_arm_id`
#include "rosidl_runtime_c/string_functions.h"

bool
oxts_msgs__msg__LeverArm__init(oxts_msgs__msg__LeverArm * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    oxts_msgs__msg__LeverArm__fini(msg);
    return false;
  }
  // lever_arm_id
  if (!rosidl_runtime_c__String__init(&msg->lever_arm_id)) {
    oxts_msgs__msg__LeverArm__fini(msg);
    return false;
  }
  // offset_x
  // offset_y
  // offset_z
  return true;
}

void
oxts_msgs__msg__LeverArm__fini(oxts_msgs__msg__LeverArm * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // lever_arm_id
  rosidl_runtime_c__String__fini(&msg->lever_arm_id);
  // offset_x
  // offset_y
  // offset_z
}

bool
oxts_msgs__msg__LeverArm__are_equal(const oxts_msgs__msg__LeverArm * lhs, const oxts_msgs__msg__LeverArm * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // lever_arm_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->lever_arm_id), &(rhs->lever_arm_id)))
  {
    return false;
  }
  // offset_x
  if (lhs->offset_x != rhs->offset_x) {
    return false;
  }
  // offset_y
  if (lhs->offset_y != rhs->offset_y) {
    return false;
  }
  // offset_z
  if (lhs->offset_z != rhs->offset_z) {
    return false;
  }
  return true;
}

bool
oxts_msgs__msg__LeverArm__copy(
  const oxts_msgs__msg__LeverArm * input,
  oxts_msgs__msg__LeverArm * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // lever_arm_id
  if (!rosidl_runtime_c__String__copy(
      &(input->lever_arm_id), &(output->lever_arm_id)))
  {
    return false;
  }
  // offset_x
  output->offset_x = input->offset_x;
  // offset_y
  output->offset_y = input->offset_y;
  // offset_z
  output->offset_z = input->offset_z;
  return true;
}

oxts_msgs__msg__LeverArm *
oxts_msgs__msg__LeverArm__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  oxts_msgs__msg__LeverArm * msg = (oxts_msgs__msg__LeverArm *)allocator.allocate(sizeof(oxts_msgs__msg__LeverArm), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(oxts_msgs__msg__LeverArm));
  bool success = oxts_msgs__msg__LeverArm__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
oxts_msgs__msg__LeverArm__destroy(oxts_msgs__msg__LeverArm * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    oxts_msgs__msg__LeverArm__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
oxts_msgs__msg__LeverArm__Sequence__init(oxts_msgs__msg__LeverArm__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  oxts_msgs__msg__LeverArm * data = NULL;

  if (size) {
    data = (oxts_msgs__msg__LeverArm *)allocator.zero_allocate(size, sizeof(oxts_msgs__msg__LeverArm), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = oxts_msgs__msg__LeverArm__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        oxts_msgs__msg__LeverArm__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
oxts_msgs__msg__LeverArm__Sequence__fini(oxts_msgs__msg__LeverArm__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      oxts_msgs__msg__LeverArm__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

oxts_msgs__msg__LeverArm__Sequence *
oxts_msgs__msg__LeverArm__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  oxts_msgs__msg__LeverArm__Sequence * array = (oxts_msgs__msg__LeverArm__Sequence *)allocator.allocate(sizeof(oxts_msgs__msg__LeverArm__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = oxts_msgs__msg__LeverArm__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
oxts_msgs__msg__LeverArm__Sequence__destroy(oxts_msgs__msg__LeverArm__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    oxts_msgs__msg__LeverArm__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
oxts_msgs__msg__LeverArm__Sequence__are_equal(const oxts_msgs__msg__LeverArm__Sequence * lhs, const oxts_msgs__msg__LeverArm__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!oxts_msgs__msg__LeverArm__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
oxts_msgs__msg__LeverArm__Sequence__copy(
  const oxts_msgs__msg__LeverArm__Sequence * input,
  oxts_msgs__msg__LeverArm__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(oxts_msgs__msg__LeverArm);
    oxts_msgs__msg__LeverArm * data =
      (oxts_msgs__msg__LeverArm *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!oxts_msgs__msg__LeverArm__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          oxts_msgs__msg__LeverArm__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!oxts_msgs__msg__LeverArm__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
