// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from oxts_msgs:msg/LeverArm.idl
// generated code does not contain a copyright notice

#ifndef OXTS_MSGS__MSG__DETAIL__LEVER_ARM__STRUCT_HPP_
#define OXTS_MSGS__MSG__DETAIL__LEVER_ARM__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__oxts_msgs__msg__LeverArm __attribute__((deprecated))
#else
# define DEPRECATED__oxts_msgs__msg__LeverArm __declspec(deprecated)
#endif

namespace oxts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LeverArm_
{
  using Type = LeverArm_<ContainerAllocator>;

  explicit LeverArm_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->lever_arm_id = "";
      this->offset_x = 0.0;
      this->offset_y = 0.0;
      this->offset_z = 0.0;
    }
  }

  explicit LeverArm_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    lever_arm_id(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->lever_arm_id = "";
      this->offset_x = 0.0;
      this->offset_y = 0.0;
      this->offset_z = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _lever_arm_id_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _lever_arm_id_type lever_arm_id;
  using _offset_x_type =
    double;
  _offset_x_type offset_x;
  using _offset_y_type =
    double;
  _offset_y_type offset_y;
  using _offset_z_type =
    double;
  _offset_z_type offset_z;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__lever_arm_id(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->lever_arm_id = _arg;
    return *this;
  }
  Type & set__offset_x(
    const double & _arg)
  {
    this->offset_x = _arg;
    return *this;
  }
  Type & set__offset_y(
    const double & _arg)
  {
    this->offset_y = _arg;
    return *this;
  }
  Type & set__offset_z(
    const double & _arg)
  {
    this->offset_z = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    oxts_msgs::msg::LeverArm_<ContainerAllocator> *;
  using ConstRawPtr =
    const oxts_msgs::msg::LeverArm_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<oxts_msgs::msg::LeverArm_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<oxts_msgs::msg::LeverArm_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      oxts_msgs::msg::LeverArm_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<oxts_msgs::msg::LeverArm_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      oxts_msgs::msg::LeverArm_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<oxts_msgs::msg::LeverArm_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<oxts_msgs::msg::LeverArm_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<oxts_msgs::msg::LeverArm_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__oxts_msgs__msg__LeverArm
    std::shared_ptr<oxts_msgs::msg::LeverArm_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__oxts_msgs__msg__LeverArm
    std::shared_ptr<oxts_msgs::msg::LeverArm_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LeverArm_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->lever_arm_id != other.lever_arm_id) {
      return false;
    }
    if (this->offset_x != other.offset_x) {
      return false;
    }
    if (this->offset_y != other.offset_y) {
      return false;
    }
    if (this->offset_z != other.offset_z) {
      return false;
    }
    return true;
  }
  bool operator!=(const LeverArm_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LeverArm_

// alias to use template instance with default allocator
using LeverArm =
  oxts_msgs::msg::LeverArm_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace oxts_msgs

#endif  // OXTS_MSGS__MSG__DETAIL__LEVER_ARM__STRUCT_HPP_
