// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from oxts_msgs:msg/NavSatRef.idl
// generated code does not contain a copyright notice

#ifndef OXTS_MSGS__MSG__DETAIL__NAV_SAT_REF__STRUCT_HPP_
#define OXTS_MSGS__MSG__DETAIL__NAV_SAT_REF__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__oxts_msgs__msg__NavSatRef __attribute__((deprecated))
#else
# define DEPRECATED__oxts_msgs__msg__NavSatRef __declspec(deprecated)
#endif

namespace oxts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct NavSatRef_
{
  using Type = NavSatRef_<ContainerAllocator>;

  explicit NavSatRef_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->latitude = 0.0;
      this->longitude = 0.0;
      this->altitude = 0.0;
      this->heading = 0.0;
    }
  }

  explicit NavSatRef_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->latitude = 0.0;
      this->longitude = 0.0;
      this->altitude = 0.0;
      this->heading = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _latitude_type =
    double;
  _latitude_type latitude;
  using _longitude_type =
    double;
  _longitude_type longitude;
  using _altitude_type =
    double;
  _altitude_type altitude;
  using _heading_type =
    double;
  _heading_type heading;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__latitude(
    const double & _arg)
  {
    this->latitude = _arg;
    return *this;
  }
  Type & set__longitude(
    const double & _arg)
  {
    this->longitude = _arg;
    return *this;
  }
  Type & set__altitude(
    const double & _arg)
  {
    this->altitude = _arg;
    return *this;
  }
  Type & set__heading(
    const double & _arg)
  {
    this->heading = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    oxts_msgs::msg::NavSatRef_<ContainerAllocator> *;
  using ConstRawPtr =
    const oxts_msgs::msg::NavSatRef_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<oxts_msgs::msg::NavSatRef_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<oxts_msgs::msg::NavSatRef_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      oxts_msgs::msg::NavSatRef_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<oxts_msgs::msg::NavSatRef_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      oxts_msgs::msg::NavSatRef_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<oxts_msgs::msg::NavSatRef_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<oxts_msgs::msg::NavSatRef_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<oxts_msgs::msg::NavSatRef_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__oxts_msgs__msg__NavSatRef
    std::shared_ptr<oxts_msgs::msg::NavSatRef_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__oxts_msgs__msg__NavSatRef
    std::shared_ptr<oxts_msgs::msg::NavSatRef_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const NavSatRef_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->latitude != other.latitude) {
      return false;
    }
    if (this->longitude != other.longitude) {
      return false;
    }
    if (this->altitude != other.altitude) {
      return false;
    }
    if (this->heading != other.heading) {
      return false;
    }
    return true;
  }
  bool operator!=(const NavSatRef_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct NavSatRef_

// alias to use template instance with default allocator
using NavSatRef =
  oxts_msgs::msg::NavSatRef_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace oxts_msgs

#endif  // OXTS_MSGS__MSG__DETAIL__NAV_SAT_REF__STRUCT_HPP_
